#pragma once
#ifdef WIN32
#define inline __inline
#endif
#include <vectormath_aos_v.h>

// May the Sony authors forgive us...
// We use shortened (yes, namespace-polluting) names for demo purposes.

#define Point3 VmathPoint3
#define Vector3 VmathVector3
#define Vector4 VmathVector4
#define Quaternion VmathQuat
#define Matrix3 VmathMatrix3
#define Matrix4 VmathMatrix4
#define Transform3 VmathTransform3

#define V3MakeFromElems vmathV3MakeFromElems_V
#define V3MakeFromP3 vmathV3MakeFromP3_V
#define V3MakeFromScalar vmathV3MakeFromScalar_V
#define V3SetX vmathV3SetX_V
#define V3SetY vmathV3SetY_V
#define V3SetZ vmathV3SetZ_V
#define V3GetX vmathV3GetX_V
#define V3GetY vmathV3GetY_V
#define V3GetZ vmathV3GetZ_V
#define V3SetElem vmathV3SetElem_V
#define V3GetElem vmathV3GetElem_V
#define V3Add vmathV3Add_V
#define V3Sub vmathV3Sub_V
#define V3AddP3 vmathV3AddP3_V
#define V3ScalarMul vmathV3ScalarMul_V
#define V3ScalarDiv vmathV3ScalarDiv_V
#define V3Neg vmathV3Neg_V
#define V3MakeXAxis vmathV3MakeXAxis_V
#define V3MakeYAxis vmathV3MakeYAxis_V
#define V3MakeZAxis vmathV3MakeZAxis_V
#define V3MulPerElem vmathV3MulPerElem_V
#define V3DivPerElem vmathV3DivPerElem_V
#define V3RecipPerElem vmathV3RecipPerElem_V
#define V3SqrtPerElem vmathV3SqrtPerElem_V
#define V3RsqrtPerElem vmathV3RsqrtPerElem_V
#define V3AbsPerElem vmathV3AbsPerElem_V
#define V3CopySignPerElem vmathV3CopySignPerElem_V
#define V3MaxPerElem vmathV3MaxPerElem_V
#define V3MinPerElem vmathV3MinPerElem_V
#define V3MaxElem vmathV3MaxElem_V
#define V3MinElem vmathV3MinElem_V
#define V3Sum vmathV3Sum_V
#define V3Dot vmathV3Dot_V
#define V3LengthSqr vmathV3LengthSqr_V
#define V3Length vmathV3Length_V
#define V3Normalize vmathV3Normalize_V
#define V3Cross vmathV3Cross_V
#define V3Outer vmathV3Outer_V
#define V3RowMul vmathV3RowMul_V
#define V3CrossMatrix vmathV3CrossMatrix_V
#define V3CrossMatrixMul vmathV3CrossMatrixMul_V
#define V3Lerp vmathV3Lerp_V
#define V3Slerp vmathV3Slerp_V
#define V3Select vmathV3Select_V
#define V4MakeFromElems vmathV4MakeFromElems_V
#define V4MakeFromV3Scalar vmathV4MakeFromV3Scalar_V
#define V4MakeFromV3 vmathV4MakeFromV3_V
#define V4MakeFromP3 vmathV4MakeFromP3_V
#define V4MakeFromQ vmathV4MakeFromQ_V
#define V4MakeFromScalar vmathV4MakeFromScalar_V
#define V4SetXYZ vmathV4SetXYZ_V
#define V4GetXYZ vmathV4GetXYZ_V
#define V4SetX vmathV4SetX_V
#define V4SetY vmathV4SetY_V
#define V4SetZ vmathV4SetZ_V
#define V4SetW vmathV4SetW_V
#define V4GetX vmathV4GetX_V
#define V4GetY vmathV4GetY_V
#define V4GetZ vmathV4GetZ_V
#define V4GetW vmathV4GetW_V
#define V4SetElem vmathV4SetElem_V
#define V4GetElem vmathV4GetElem_V
#define V4Add vmathV4Add_V
#define V4Sub vmathV4Sub_V
#define V4ScalarMul vmathV4ScalarMul_V
#define V4ScalarDiv vmathV4ScalarDiv_V
#define V4Neg vmathV4Neg_V
#define V4MakeXAxis vmathV4MakeXAxis_V
#define V4MakeYAxis vmathV4MakeYAxis_V
#define V4MakeZAxis vmathV4MakeZAxis_V
#define V4MakeWAxis vmathV4MakeWAxis_V
#define V4MulPerElem vmathV4MulPerElem_V
#define V4DivPerElem vmathV4DivPerElem_V
#define V4RecipPerElem vmathV4RecipPerElem_V
#define V4SqrtPerElem vmathV4SqrtPerElem_V
#define V4RsqrtPerElem vmathV4RsqrtPerElem_V
#define V4AbsPerElem vmathV4AbsPerElem_V
#define V4CopySignPerElem vmathV4CopySignPerElem_V
#define V4MaxPerElem vmathV4MaxPerElem_V
#define V4MinPerElem vmathV4MinPerElem_V
#define V4MaxElem vmathV4MaxElem_V
#define V4MinElem vmathV4MinElem_V
#define V4Sum vmathV4Sum_V
#define V4Dot vmathV4Dot_V
#define V4LengthSqr vmathV4LengthSqr_V
#define V4Length vmathV4Length_V
#define V4Normalize vmathV4Normalize_V
#define V4Outer vmathV4Outer_V
#define V4Lerp vmathV4Lerp_V
#define V4Slerp vmathV4Slerp_V
#define V4Select vmathV4Select_V
#define P3MakeFromElems vmathP3MakeFromElems_V
#define P3MakeFromV3 vmathP3MakeFromV3_V
#define P3MakeFromScalar vmathP3MakeFromScalar_V
#define P3SetX vmathP3SetX_V
#define P3SetY vmathP3SetY_V
#define P3SetZ vmathP3SetZ_V
#define P3GetX vmathP3GetX_V
#define P3GetY vmathP3GetY_V
#define P3GetZ vmathP3GetZ_V
#define P3SetElem vmathP3SetElem_V
#define P3GetElem vmathP3GetElem_V
#define P3Sub vmathP3Sub_V
#define P3AddV3 vmathP3AddV3_V
#define P3SubV3 vmathP3SubV3_V
#define P3MulPerElem vmathP3MulPerElem_V
#define P3DivPerElem vmathP3DivPerElem_V
#define P3RecipPerElem vmathP3RecipPerElem_V
#define P3SqrtPerElem vmathP3SqrtPerElem_V
#define P3RsqrtPerElem vmathP3RsqrtPerElem_V
#define P3AbsPerElem vmathP3AbsPerElem_V
#define P3CopySignPerElem vmathP3CopySignPerElem_V
#define P3MaxPerElem vmathP3MaxPerElem_V
#define P3MinPerElem vmathP3MinPerElem_V
#define P3MaxElem vmathP3MaxElem_V
#define P3MinElem vmathP3MinElem_V
#define P3Sum vmathP3Sum_V
#define P3Scale vmathP3Scale_V
#define P3NonUniformScale vmathP3NonUniformScale_V
#define P3Projection vmathP3Projection_V
#define P3DistSqrFromOrigin vmathP3DistSqrFromOrigin_V
#define P3DistFromOrigin vmathP3DistFromOrigin_V
#define P3DistSqr vmathP3DistSqr_V
#define P3Dist vmathP3Dist_V
#define P3Lerp vmathP3Lerp_V
#define P3Select vmathP3Select_V
#define QMakeFromElems vmathQMakeFromElems_V
#define QMakeFromV3Scalar vmathQMakeFromV3Scalar_V
#define QMakeFromV4 vmathQMakeFromV4_V
#define QMakeFromM3 vmathQMakeFromM3_V
#define QMakeFromScalar vmathQMakeFromScalar_V
#define QSetXYZ vmathQSetXYZ_V
#define QGetXYZ vmathQGetXYZ_V
#define QSetX vmathQSetX_V
#define QSetY vmathQSetY_V
#define QSetZ vmathQSetZ_V
#define QSetW vmathQSetW_V
#define QGetX vmathQGetX_V
#define QGetY vmathQGetY_V
#define QGetZ vmathQGetZ_V
#define QGetW vmathQGetW_V
#define QSetElem vmathQSetElem_V
#define QGetElem vmathQGetElem_V
#define QAdd vmathQAdd_V
#define QSub vmathQSub_V
#define QMul vmathQMul_V
#define QScalarMul vmathQScalarMul_V
#define QScalarDiv vmathQScalarDiv_V
#define QNeg vmathQNeg_V
#define QMakeIdentity vmathQMakeIdentity_V
#define QMakeRotationArc vmathQMakeRotationArc_V
#define QMakeRotationAxis vmathQMakeRotationAxis_V
#define QMakeRotationX vmathQMakeRotationX_V
#define QMakeRotationY vmathQMakeRotationY_V
#define QMakeRotationZ vmathQMakeRotationZ_V
#define QConj vmathQConj_V
#define QRotate vmathQRotate_V
#define QDot vmathQDot_V
#define QNorm vmathQNorm_V
#define QLength vmathQLength_V
#define QNormalize vmathQNormalize_V
#define QLerp vmathQLerp_V
#define QSlerp vmathQSlerp_V
#define QSquad vmathQSquad_V
#define QSelect vmathQSelect_V
#define M3MakeFromCols vmathM3MakeFromCols_V
#define M3MakeFromQ vmathM3MakeFromQ_V
#define M3MakeFromScalar vmathM3MakeFromScalar_V
#define M3SetCol0 vmathM3SetCol0_V
#define M3SetCol1 vmathM3SetCol1_V
#define M3SetCol2 vmathM3SetCol2_V
#define M3GetCol0 vmathM3GetCol0_V
#define M3GetCol1 vmathM3GetCol1_V
#define M3GetCol2 vmathM3GetCol2_V
#define M3SetCol vmathM3SetCol_V
#define M3SetRow vmathM3SetRow_V
#define M3GetCol vmathM3GetCol_V
#define M3GetRow vmathM3GetRow_V
#define M3SetElem vmathM3SetElem_V
#define M3GetElem vmathM3GetElem_V
#define M3Add vmathM3Add_V
#define M3Sub vmathM3Sub_V
#define M3Neg vmathM3Neg_V
#define M3ScalarMul vmathM3ScalarMul_V
#define M3MulV3 vmathM3MulV3_V
#define M3Mul vmathM3Mul_V
#define M3MakeIdentity vmathM3MakeIdentity_V
#define M3MakeRotationX vmathM3MakeRotationX_V
#define M3MakeRotationY vmathM3MakeRotationY_V
#define M3MakeRotationZ vmathM3MakeRotationZ_V
#define M3MakeRotationZYX vmathM3MakeRotationZYX_V
#define M3MakeRotationAxis vmathM3MakeRotationAxis_V
#define M3MakeRotationQ vmathM3MakeRotationQ_V
#define M3MakeScale vmathM3MakeScale_V
#define M3AppendScale vmathM3AppendScale_V
#define M3PrependScale vmathM3PrependScale_V
#define M3MulPerElem vmathM3MulPerElem_V
#define M3AbsPerElem vmathM3AbsPerElem_V
#define M3Transpose vmathM3Transpose_V
#define M3Inverse vmathM3Inverse_V
#define M3Determinant vmathM3Determinant_V
#define M3Select vmathM3Select_V
#define M4MakeFromCols vmathM4MakeFromCols_V
#define M4MakeFromT3 vmathM4MakeFromT3_V
#define M4MakeFromM3V3 vmathM4MakeFromM3V3_V
#define M4MakeFromQV3 vmathM4MakeFromQV3_V
#define M4MakeFromScalar vmathM4MakeFromScalar_V
#define M4SetUpper3x3 vmathM4SetUpper3x3_V
#define M4GetUpper3x3 vmathM4GetUpper3x3_V
#define M4SetTranslation vmathM4SetTranslation_V
#define M4GetTranslation vmathM4GetTranslation_V
#define M4SetCol0 vmathM4SetCol0_V
#define M4SetCol1 vmathM4SetCol1_V
#define M4SetCol2 vmathM4SetCol2_V
#define M4SetCol3 vmathM4SetCol3_V
#define M4GetCol0 vmathM4GetCol0_V
#define M4GetCol1 vmathM4GetCol1_V
#define M4GetCol2 vmathM4GetCol2_V
#define M4GetCol3 vmathM4GetCol3_V
#define M4SetCol vmathM4SetCol_V
#define M4SetRow vmathM4SetRow_V
#define M4GetCol vmathM4GetCol_V
#define M4GetRow vmathM4GetRow_V
#define M4SetElem vmathM4SetElem_V
#define M4GetElem vmathM4GetElem_V
#define M4Add vmathM4Add_V
#define M4Sub vmathM4Sub_V
#define M4Neg vmathM4Neg_V
#define M4ScalarMul vmathM4ScalarMul_V
#define M4MulV4 vmathM4MulV4_V
#define M4MulV3 vmathM4MulV3_V
#define M4MulP3 vmathM4MulP3_V
#define M4Mul vmathM4Mul_V
#define M4MulT3 vmathM4MulT3_V
#define M4MakeIdentity vmathM4MakeIdentity_V
#define M4MakeRotationX vmathM4MakeRotationX_V
#define M4MakeRotationY vmathM4MakeRotationY_V
#define M4MakeRotationZ vmathM4MakeRotationZ_V
#define M4MakeRotationZYX vmathM4MakeRotationZYX_V
#define M4MakeRotationAxis vmathM4MakeRotationAxis_V
#define M4MakeRotationQ vmathM4MakeRotationQ_V
#define M4MakeScale vmathM4MakeScale_V
#define M4MakeTranslation vmathM4MakeTranslation_V
#define M4MakeLookAt vmathM4MakeLookAt_V
#define M4MakePerspective vmathM4MakePerspective_V
#define M4MakeFrustum vmathM4MakeFrustum_V
#define M4MakeOrthographic vmathM4MakeOrthographic_V
#define M4AppendScale vmathM4AppendScale_V
#define M4PrependScale vmathM4PrependScale_V
#define M4MulPerElem vmathM4MulPerElem_V
#define M4AbsPerElem vmathM4AbsPerElem_V
#define M4Transpose vmathM4Transpose_V
#define M4Inverse vmathM4Inverse_V
#define M4AffineInverse vmathM4AffineInverse_V
#define M4OrthoInverse vmathM4OrthoInverse_V
#define M4Determinant vmathM4Determinant_V
#define M4Select vmathM4Select_V
#define T3MakeFromCols vmathT3MakeFromCols_V
#define T3MakeFromM3V3 vmathT3MakeFromM3V3_V
#define T3MakeFromQV3 vmathT3MakeFromQV3_V
#define T3MakeFromScalar vmathT3MakeFromScalar_V
#define T3SetUpper3x3 vmathT3SetUpper3x3_V
#define T3GetUpper3x3 vmathT3GetUpper3x3_V
#define T3SetTranslation vmathT3SetTranslation_V
#define T3GetTranslation vmathT3GetTranslation_V
#define T3SetCol0 vmathT3SetCol0_V
#define T3SetCol1 vmathT3SetCol1_V
#define T3SetCol2 vmathT3SetCol2_V
#define T3SetCol3 vmathT3SetCol3_V
#define T3GetCol0 vmathT3GetCol0_V
#define T3GetCol1 vmathT3GetCol1_V
#define T3GetCol2 vmathT3GetCol2_V
#define T3GetCol3 vmathT3GetCol3_V
#define T3SetCol vmathT3SetCol_V
#define T3SetRow vmathT3SetRow_V
#define T3GetCol vmathT3GetCol_V
#define T3GetRow vmathT3GetRow_V
#define T3SetElem vmathT3SetElem_V
#define T3GetElem vmathT3GetElem_V
#define T3MulV3 vmathT3MulV3_V
#define T3MulP3 vmathT3MulP3_V
#define T3Mul vmathT3Mul_V
#define T3MakeIdentity vmathT3MakeIdentity_V
#define T3MakeRotationX vmathT3MakeRotationX_V
#define T3MakeRotationY vmathT3MakeRotationY_V
#define T3MakeRotationZ vmathT3MakeRotationZ_V
#define T3MakeRotationZYX vmathT3MakeRotationZYX_V
#define T3MakeRotationAxis vmathT3MakeRotationAxis_V
#define T3MakeRotationQ vmathT3MakeRotationQ_V
#define T3MakeScale vmathT3MakeScale_V
#define T3MakeTranslation vmathT3MakeTranslation_V
#define T3AppendScale vmathT3AppendScale_V
#define T3PrependScale vmathT3PrependScale_V
#define T3MulPerElem vmathT3MulPerElem_V
#define T3AbsPerElem vmathT3AbsPerElem_V
#define T3Inverse vmathT3Inverse_V
#define T3OrthoInverse vmathT3OrthoInverse_V
#define T3Select vmathT3Select_V
